#ifndef ABOUTEX_ABOUTBOX_HPP_INCLUDED
#define ABOUTEX_ABOUTBOX_HPP_INCLUDED

#if _MSC_VER > 1020
#  pragma once
#endif // _MSC_VER

//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
//  aboutbox.hpp
//  This is a part of the aboutex source code.
//
//  Copyright (C) 1997-2003 The LiteStep Development Team
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-

#include "common.hpp"


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// interface IMenuItem
//
class IMenuItem
{
protected:
    HWND m_hBox;
    HWND m_hListView;
    
    IMenuItem(HWND hBox, HWND hListView)
        : m_hBox(hBox), m_hListView(hListView) { }
    
public:
    virtual ~IMenuItem() {}
    
    virtual void Attach();
    virtual void Detach();
    
    virtual void OnLeftClick(int nItem) { }
    virtual void OnLeftDoubleClick(int nItem) { }
    virtual void OnRightClick(int nItem) { }
    virtual void OnRightDoubleClick(int nItem) { }
    
    int     _TrackPopupMenu(HMENU hMenu, const POINT& cursorPos) const
    {
        return TrackPopupMenu(hMenu,
            TPM_LEFTALIGN | TPM_RETURNCMD | TPM_NONOTIFY,
            cursorPos.x, cursorPos.y, 0, m_hBox, NULL);
    }
};


//=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//
// class AboutBox
//
class AboutBox
{
    HWND m_hBox;
    IMenuItem* pCurItem;
    
public:
    AboutBox();
    ~AboutBox();
    
    bool    Show();
    
    bool    OnInitDialog(HWND hBox);
    HBRUSH  OnCtlColorStatic(int id, HDC hDC) const;
    bool    OnCommand(WORD wNotifyCode, WORD wID);
    bool    OnNotify(int nID, LPNMHDR pnmh) const;
    
private:
    HWND    _GetListView() const { return GetDlgItem(m_hBox, IDC_LISTVIEW); }
    bool    _SetNewItem(int index);
};


#endif // !defined(ABOUTEX_ABOUTBOX_HPP_INCLUDED)
